      SUBROUTINE XPMCRT(nx,ny,f,fmin,fmax,fname)
C----------------------------------------------------------------C
C           2D field data ---> XPM file (32 colors)              C
C     (INTEGER) nx,ny : dimensions of two-dimendional array f    C
C     (DOUBLE PRECISION) f(i,j) : field value of site (i,j)      C
C     (DOUBLE PRECISION) fmin,fmax : lower and upper bounds of   C
C                                    the field values f(i,j)     C
C     (CHARACTER) fname : output file name                       C
C                                                                C
C                                          Okuzono, Tohru 1996   C
C     The colormap used here was edited by Fumiko Sasaki, 1996   C
C----------------------------------------------------------------C

      PARAMETER( NMAX=1024 )
      PARAMETER( nc = 32, np = 1 )
      DOUBLE PRECISION f(nx,ny),fmin,fmax
      CHARACTER  cz*1024,cname*32,fname*(*)

      DATA cname/'0123456789abcdefghijklmnopqrstuv'/

      IF(nx.GT.NMAX) THEN
	WRITE(6,*) 'System dimensions must be smaller than',NMAX
	WRITE(6,*) 'nx=',nx
	STOP
      ENDIF

      dcol=(fmax-fmin)/32.0
      IF( dcol .LT. 0.0 ) THEN
         dcol=-dcol
	 fmin=fmax
      ELSEIF( dcol .EQ. 0.0 ) THEN
         dcol=1.0/32.0
	 fmin=0.0
      ENDIF
      dcoli=1.0/dcol

      OPEN(99,FILE=fname)
      WRITE(99,'(A9)') '/* XPM */'
      WRITE(99,'(A)') 'static char *fmtemp_xpm[] = {'
      WRITE(99,'(A,4I5,A)') '"',nx,ny,nc,np,'",'
      WRITE(99,'(A)') '"0 c #0000b7",'
      WRITE(99,'(A)') '"1 c #0000d9",'
      WRITE(99,'(A)') '"2 c #0023f7",'
      WRITE(99,'(A)') '"3 c #0042fe",'
      WRITE(99,'(A)') '"4 c #005cfd",'
      WRITE(99,'(A)') '"5 c #007dfb",'
      WRITE(99,'(A)') '"6 c #009bf9",'
      WRITE(99,'(A)') '"7 c #00bdf5",'
      WRITE(99,'(A)') '"8 c #00d6f0",'
      WRITE(99,'(A)') '"9 c #00e8e8",'
      WRITE(99,'(A)') '"a c #00f3db",'
      WRITE(99,'(A)') '"b c #00fbc8",'
      WRITE(99,'(A)') '"c c #00ffa9",'
      WRITE(99,'(A)') '"d c #00ff8b",'
      WRITE(99,'(A)') '"e c #00ff5f",'
      WRITE(99,'(A)') '"f c #00ff2e",'
      WRITE(99,'(A)') '"g c #00ff00",'
      WRITE(99,'(A)') '"h c #3dff00",'
      WRITE(99,'(A)') '"i c #6fff00",'
      WRITE(99,'(A)') '"j c #91ff00",'
      WRITE(99,'(A)') '"k c #b4ff00",'
      WRITE(99,'(A)') '"l c #ccfb00",'
      WRITE(99,'(A)') '"m c #e0f300",'
      WRITE(99,'(A)') '"n c #eae800",'
      WRITE(99,'(A)') '"o c #f1d400",'
      WRITE(99,'(A)') '"p c #f5b900",'
      WRITE(99,'(A)') '"q c #f89b00",'
      WRITE(99,'(A)') '"r c #fa7600",'
      WRITE(99,'(A)') '"s c #fc5500",'
      WRITE(99,'(A)') '"t c #fd3b00",'
      WRITE(99,'(A)') '"u c #fe1c00",'
      WRITE(99,'(A)') '"v c #ff0000",'

      DO 10 j=1,ny
      DO 11 i=1,nx
	icol=INT((f(i,j)-fmin)*dcoli)+1
	IF( icol.LT.1 ) icol=1
	IF( icol.GT.32 ) icol=32
	cz(i:i)=cname(icol:icol)
   11 CONTINUE
      WRITE(99,'(3A)') '"',cz(:nx),'",'
   10 CONTINUE
      WRITE(99,'(A)') '};'
      CLOSE(99)

      RETURN
      END
